#include "Precompiled.h"

#include <ta_libc.h>
#include <stdlib.h>

#include "AsirikuyMachineLearningCWrapper.hpp"
#include "EasyTradeCWrapper.hpp"
#include "OrderSignals.h"
#include "OrderManagement.h"
#include "AsirikuyTime.h"

typedef enum additionalSettings_t
{
	LEARNING_PERIOD      = ADDITIONAL_PARAM_1,
	BARS_USED            = ADDITIONAL_PARAM_2,
	TRADING_HOUR         = ADDITIONAL_PARAM_3,
        HORIZON              = ADDITIONAL_PARAM_4
} AdditionalSettings;

AsirikuyReturnCode runSystem_1d1h(StrategyParams* pParams)
{
  AsirikuyReturnCode returnCode = SUCCESS;
  double stopLoss, takeProfit, atr;
  double ensemblePrediction = 0;
  struct tm timeInfo;
  double spread, newSL;
  int orderAge;
  int i;

  safe_gmtime(&timeInfo, openTime(0));

  atr = iAtr(DAILY_RATES, 20, 1);
  
  stopLoss   =  atr*parameter(SL_ATR_MULTIPLIER);
  takeProfit =  atr*parameter(TP_ATR_MULTIPLIER);

  if(hour() == (int)parameter(TRADING_HOUR)){

	ensemblePrediction += LR_Prediction_i_simpleReturn_o_mfemaeDifference((int)parameter(LEARNING_PERIOD), (int)parameter(BARS_USED), (int)parameter(TRADING_HOUR), (int)parameter(HORIZON)) ;
 
    
  if(ensemblePrediction > 0)
	{
    return openOrUpdateLongEasy(0, stopLoss);
  }
	else if(ensemblePrediction < 0)
	{
    return openOrUpdateShortEasy(0, stopLoss);
  }
  }

  return SUCCESS;
}

